#line 1562 "Dismantle.nw"
#include "Dismantle.hpp"

namespace Dismantle {
  
#line 40 "Dismantle.nw"
Label *fresh_label() {
  static int nextLabel = 0;
  std::ostringstream os;
  os << "L" << nextLabel++;
  return new Label(os.str());
}
#line 1566 "Dismantle.nw"
  
#line 49 "Dismantle.nw"
VariableSymbol *Dismantler2::new_unique_var(string basename, TypeSymbol *ts) {
  assert(ts);
  assert(module);
  assert(module->variables);
  string name = basename;
  char ch = 'a';
  while (module->variables->contains(name))
    name = basename + '_' + ch++;
  VariableSymbol *vs = new VariableSymbol(name, ts, 0);
  module->variables->enter(vs);
  return vs;
}
#line 1567 "Dismantle.nw"
  
#line 64 "Dismantle.nw"
void Dismantler2::add_new_thread(Parallel *par, Statement *body) {
  assert(integer_type);
  Label *catch0 = fresh_label();
  Label *cont = fresh_label();
  VariableSymbol *level_var = new_unique_var("level", integer_type);
  par->newThread(catch0, cont, body, level_var);
}
#line 1568 "Dismantle.nw"
}
