#ifndef _GRC_PRINTER_HPP
#  define _GRC_PRINTER_HPP
#  include "AST.hpp"
#  include "EsterelPrinter.hpp"
#  include <iostream>
#  include <map>

namespace AST {

  typedef  map<GRCNode *, int> Nodemap;
  void GRCDot(std::ostream &, GRCNode *, Module *, Nodemap &refmap);
  
  class GRCDP : public Visitor {
    std::ostream &o;
    Nodemap &refmap;
    Nodemap reached;
    vector<GRCNode*>topo;

    int nextnum;
    int mynum;

    int drawpar, drawblue;

    EsterelPrinter ep;
  public:
    GRCDP(std::ostream &oo, Nodemap &nmap, int nextnum) :
      o(oo), refmap(nmap), nextnum(nextnum), drawpar(0), drawblue(0), ep(oo) {}
    virtual ~GRCDP() {}

    void visit(GRCNode *);

    Status visit(Switch &);
    Status visit(Test &);
    Status visit(Terminate &);
    Status visit(Sync &);
    Status visit(Fork &);
    Status visit(Action &);
    Status visit(Enter &);
    Status visit(Leave &);
    Status visit(STexcl &);
    Status visit(STref &);
    Status visit(STpar &);
    Status visit(STleaf &);
    Status visit(TopGRC &);

    Status visit(Nop &);
    Status visit(RecT1&);

    Status visit(DefineSignal &);
    Status visit(UndefineSignal &);

    void drawSTlink(GRCNode *, STNode *);
    void drawparents();

  };

};

#endif
