#include "IR.hpp"
#include "AST.hpp"
#include "GRCPrinter.hpp"
#include <iostream>
#include <stdlib.h>

int main()
{

  try {

    std::cerr <<"grcdot: trying reading file ...\n";

    IR::XMListream r(std::cin);
    IR::Node *n;
    r >> n;

    std::cerr <<"grcdot: file read OK\n";

    AST::Modules *mods = dynamic_cast<AST::Modules*>(n);
    if (!mods) throw IR::Error("Root node is not a Modules object");

    for ( std::vector<AST::Module*>::iterator i = mods->modules.begin() ;
	  i != mods->modules.end() ; i++ ) {
      assert(*i);

      AST::GRCNode *gn = dynamic_cast<AST::GRCNode*>((*i)->body);
      assert(gn);

      AST::Nodemap refmap;
      AST::GRCDot(std::cout, gn, *i, refmap);
    }

  } catch (IR::Error &e) {
    std::cerr << e.s << std::endl;
    exit(-1);
  }

  return 0;

}
